/*
** ADMXRC3 API Utility library code for getting information about devices.
*/

#include <admxrc3.h>
#include <admxrc3ut.h>

const char*
ADMXRC3UT_GetModelNameA(
  ADMXRC3_MODEL_TYPE model)
{
  switch (model) {
  case ADMXRC3_MODEL_GENERIC:
    return "Generic ADB3 Device";
    
  case ADMXRC3_MODEL_ADMXRC2:
    return "ADM-XRC-II";
    
  case ADMXRC3_MODEL_ADPEXRC5T:
    return "ADPE-XRC-5T";
    
  case ADMXRC3_MODEL_ADMXRC6TL:
    return "ADM-XRC-6TL";
    
  case ADMXRC3_MODEL_ADMXRC6T1:
    return "ADM-XRC-6T1";
    
  case ADMXRC3_MODEL_ADMXRC6TGE:
    return "ADM-XRC-6TGE";
    
  case ADMXRC3_MODEL_ADMXRC6TADV8:
    return "ADM-XRC-6T-ADV8";
    
  case ADMXRC3_MODEL_ADPEXRC6T:
    return "ADPE-XRC-6T";
    
  case ADMXRC3_MODEL_ADPEXRC6TL:
    return "ADPE-XRC-6TL";
    
  case ADMXRC3_MODEL_ADPEXRC6TADV_C:
    return "ADPE-XRC-6T-ADV Controller";
    
  case ADMXRC3_MODEL_ADPEXRC6TADV_T:
    return "ADPE-XRC-6T-ADV Target";
    
  case ADMXRC3_MODEL_ADMXRC7K1:
    return "ADM-XRC-7K1";
    
  case ADMXRC3_MODEL_ADMXRC6TDA1:
    return "ADM-XRC-6T-DA1";
    
  case ADMXRC3_MODEL_ADMXRC7V1:
    return "ADM-XRC-7V1";
    
  case ADMXRC3_MODEL_ADMVPX37V2:
    return "ADM-VPX3-7V2";
    
  case ADMXRC3_MODEL_ADMXRC6TGEL:
    return "ADM-XRC-6TGEL";
    
  case ADMXRC3_MODEL_ADMPCIE7V3:
    return "ADM-PCIE-7V3";
    
  case ADMXRC3_MODEL_ADMXRC7Z1:
    return "ADM-XRC-7Z1";
      
  case ADMXRC3_MODEL_ADMXRC7Z2:
    return "ADM-XRC-7Z2";
      
  case ADMXRC3_MODEL_ADMXRCKU1:
    return "ADM-XRC-KU1";
      
  case ADMXRC3_MODEL_ADMPCIEKU3:
    return "ADM-PCIE-KU3";
      
  case ADMXRC3_MODEL_ADMPCIE8V3:
    return "ADM-PCIE-8V3";
      
  case ADMXRC3_MODEL_ADMPCIE8K5:
    return "ADM-PCIE-8K5";
      
  default:
    return "Unknown model";
  }
}
  
const wchar_t*
ADMXRC3UT_GetModelNameW(
  ADMXRC3_MODEL_TYPE model)
{
  switch (model) {
  case ADMXRC3_MODEL_GENERIC:
    return L"Generic ADB3 Device";
    
  case ADMXRC3_MODEL_ADMXRC2:
    return L"ADM-XRC-II";
    
  case ADMXRC3_MODEL_ADPEXRC5T:
    return L"ADPE-XRC-5T";
    
  case ADMXRC3_MODEL_ADMXRC6TL:
    return L"ADM-XRC-6TL";
    
  case ADMXRC3_MODEL_ADMXRC6T1:
    return L"ADM-XRC-6T1";
    
  case ADMXRC3_MODEL_ADMXRC6TGE:
    return L"ADM-XRC-6TGE";
    
  case ADMXRC3_MODEL_ADMXRC6TADV8:
    return L"ADM-XRC-6T-ADV8";
    
  case ADMXRC3_MODEL_ADPEXRC6T:
    return L"ADPE-XRC-6T";
    
  case ADMXRC3_MODEL_ADPEXRC6TL:
    return L"ADPE-XRC-6TL";
    
  case ADMXRC3_MODEL_ADPEXRC6TADV_C:
    return L"ADPE-XRC-6T-ADV Controller";
    
  case ADMXRC3_MODEL_ADPEXRC6TADV_T:
    return L"ADPE-XRC-6T-ADV Target";
    
  case ADMXRC3_MODEL_ADMXRC7K1:
    return L"ADM-XRC-7K1";
    
  case ADMXRC3_MODEL_ADMXRC6TDA1:
    return L"ADM-XRC-6T-DA1";
    
  case ADMXRC3_MODEL_ADMXRC7V1:
    return L"ADM-XRC-7V1";
    
  case ADMXRC3_MODEL_ADMVPX37V2:
    return L"ADM-VPX3-7V2";
    
  case ADMXRC3_MODEL_ADMXRC6TGEL:
    return L"ADM-XRC-6TGEL";
    
  case ADMXRC3_MODEL_ADMPCIE7V3:
    return L"ADM-PCIE-7V3";
    
  case ADMXRC3_MODEL_ADMXRC7Z1:
    return L"ADM-XRC-7Z1";
      
  case ADMXRC3_MODEL_ADMXRC7Z2:
    return L"ADM-XRC-7Z2";
      
  case ADMXRC3_MODEL_ADMXRCKU1:
    return L"ADM-XRC-KU1";
      
  case ADMXRC3_MODEL_ADMPCIEKU3:
    return L"ADM-PCIE-KU3";
      
  case ADMXRC3_MODEL_ADMPCIE8V3:
    return L"ADM-PCIE-8V3";
      
  case ADMXRC3_MODEL_ADMPCIE8K5:
    return L"ADM-PCIE-8K5";
      
  default:
    return L"Unknown model";
  }
}

const char*
ADMXRC3UT_GetModelTagA(
  ADMXRC3_MODEL_TYPE model)
{
  switch (model) {
  case ADMXRC3_MODEL_ADPEXRC5T:
    return "adpexrc5t";

  case ADMXRC3_MODEL_ADMXRC6TL:
    return "admxrc6tl";

  case ADMXRC3_MODEL_ADMXRC6T1:
    return "admxrc6t1";

  case ADMXRC3_MODEL_ADMXRC6TGE:
    return "admxrc6tge";

  case ADMXRC3_MODEL_ADMXRC6TGEL:
    return "admxrc6tgel";

  case ADMXRC3_MODEL_ADMXRC6TADV8:
    return "admxrc6tadv8";

  case ADMXRC3_MODEL_ADPEXRC6T:
    return "adpexrc6t";

  case ADMXRC3_MODEL_ADPEXRC6TL:
    return "adpexrc6tl";

  case ADMXRC3_MODEL_ADPEXRC6TADV_C:
    return "adpexrc6tadv_c";

  case ADMXRC3_MODEL_ADPEXRC6TADV_T:
    return "adpexrc6tadv";

  case ADMXRC3_MODEL_ADMXRC7K1:
    return "admxrc7k1";

  case ADMXRC3_MODEL_ADMXRC6TDA1:
    return "admxrc6tda1";

  case ADMXRC3_MODEL_ADMXRC7V1:
    return "admxrc7v1";

  case ADMXRC3_MODEL_ADMVPX37V2:
    return "admvpx37v2";

  case ADMXRC3_MODEL_ADMPCIE7V3:
    return "admpcie7v3";

  case ADMXRC3_MODEL_ADMXRCKU1:
    return "admxrcku1";
      
  case ADMXRC3_MODEL_ADMPCIEKU3:
    return "admpcieku3";
      
  case ADMXRC3_MODEL_ADMPCIE8V3:
    return "admpcie8v3";
      
  case ADMXRC3_MODEL_ADMPCIE8K5:
    return "admpcie8k5";
      
  default:
    return "unknown";
  }
}
  
const wchar_t*
ADMXRC3UT_GetModelTagW(
  ADMXRC3_MODEL_TYPE model)
{
  switch (model) {
  case ADMXRC3_MODEL_ADPEXRC5T:
    return L"adpexrc5t";

  case ADMXRC3_MODEL_ADMXRC6TL:
    return L"admxrc6tl";

  case ADMXRC3_MODEL_ADMXRC6T1:
    return L"admxrc6t1";

  case ADMXRC3_MODEL_ADMXRC6TGE:
    return L"admxrc6tge";

  case ADMXRC3_MODEL_ADMXRC6TGEL:
    return L"admxrc6tgel";

  case ADMXRC3_MODEL_ADMXRC6TADV8:
    return L"admxrc6tadv8";

  case ADMXRC3_MODEL_ADPEXRC6T:
    return L"adpexrc6t";

  case ADMXRC3_MODEL_ADPEXRC6TL:
    return L"adpexrc6tl";

  case ADMXRC3_MODEL_ADPEXRC6TADV_C:
    return L"adpexrc6tadv_c";

  case ADMXRC3_MODEL_ADPEXRC6TADV_T:
    return L"adpexrc6tadv";

  case ADMXRC3_MODEL_ADMXRC7K1:
    return L"admxrc7k1";

  case ADMXRC3_MODEL_ADMXRC6TDA1:
    return L"admxrc6tda1";

  case ADMXRC3_MODEL_ADMXRC7V1:
    return L"admxrc7v1";

  case ADMXRC3_MODEL_ADMVPX37V2:
    return L"admvpx37v2";

  case ADMXRC3_MODEL_ADMPCIE7V3:
    return L"admpcie7v3";

  case ADMXRC3_MODEL_ADMXRCKU1:
    return L"admxrcku1";
      
  case ADMXRC3_MODEL_ADMPCIEKU3:
    return L"admpcieku3";
      
  case ADMXRC3_MODEL_ADMPCIE8V3:
    return L"admpcie8v3";
      
  case ADMXRC3_MODEL_ADMPCIE8K5:
    return L"admpcie8k5";
      
  default:
    return L"unknown";
  }
}
